#ifndef in_led
  #define in_led

  #include <avr/io.h>

  // ----------------------------------------------------
  // UART Button (Aktivierung / Deaktivierung UART-USB bridge)
  // ----------------------------------------------------
  #define button_ddr     DDRB
  #define button_port    PORTB
  #define button         PB0
  #define button_in      PINB

  #define button_init()  { button_ddr= (1 << button); button_port= (1 << button); }
  #define is_button()    (!(((button_in) & (1 << button)) >> button))

  // ----------------------------------------------------
  // gruene LED zeigt Flashaktivitaet an
  // ----------------------------------------------------
  #define led_gn           PC2
  #define led_gn_dir       DDRC
  #define led_gn_port      PORTC

  #define led_gn_init()    (led_gn_dir |= 1 << led_gn)
  #define led_gn_set()     (led_gn_port |= 1 << led_gn)
  #define led_gn_clr()     (led_gn_port &= ~(1 << led_gn))

  // ----------------------------------------------------
  // gelbe LED als Programmer ready Anzeige
  // ----------------------------------------------------
  #define led_ge           PC5
  #define led_ge_dir       DDRC
  #define led_ge_port      PORTC

  #define led_ge_init()    (led_gn_dir |= 1 << led_ge)
  #define led_ge_set()     (led_gn_port |= 1 << led_ge)
  #define led_ge_clr()     (led_gn_port &= ~(1 << led_ge))

  // ----------------------------------------------------
  // rote LED als Anzeige fuer USB-UART bridge aktiv
  // ----------------------------------------------------
  #define led_rt           PD5
  #define led_rt_dir       DDRD
  #define led_rt_port      PORTD

  #define led_rt_init()    (led_rt_dir |= 1 << led_rt)
  #define led_rt_set()     (led_rt_port |= 1 << led_rt)
  #define led_rt_clr()     (led_rt_port &= ~(1 << led_rt))

#endif //LED_H
