program flash51n2;

uses
  sysutils,synaser;

const
  dtime_clear     = 200;
  dtime_hi        = 83;
  dtime_med       = 10;
  dtime_lo        = 2;
  dtime_send	  = 150;
  dtime_s2051     = 3;
  dtime_pagemode  = 48;
  dtime_pagemode2 = 48;


var
  sport       : string;
  sparity     : char;
  sdbit,ssbit : byte;
  sbaud       : longint;
  ser         : tblockserial;
  ch          : char;
  tdat        : text;
  s,hs,hs2    : string;
  err         : integer;
  ub          : byte;
  bytelen     : byte;
  fadress     : word;
  highadress  : word;
  banz        : word;
  b           : byte;
  mcuident    : byte;
  resmcu      : boolean;
  filename    : string;
  portname    : string;
  wcx		  : word;
  readlength  : word;
  nowait	  : boolean;

  binarray    : array[0..65535] of byte;


procedure txpbarscala(pbaranzahl : byte);
var
  b, b2, b3       : byte;

begin
  write('Writing |');
  b2:= pbaranzahl;
  for b:= 0 to b2 do
  begin
    b3:= b mod 10;
    if (b3= 0) then
    begin
      write('|');
    end else
    begin
      write('-');
    end;
  end;
end;

procedure txpbarscala2(pbaranzahl : byte);
var
  b, b2, b3       : byte;

begin
  write('Reading |');
  b2:= pbaranzahl;
  for b:= 0 to b2 do
  begin
    b3:= b mod 10;
    if (b3= 0) then
    begin
      write('|');
    end else
    begin
      write('-');
    end;
  end;
end;

procedure txpbar(startzeit : comp; maxwert : word; value : word; ch : char; pbaranzahl : byte);
var
  r          : real;
  zanz       : byte;
  ts         : ttimestamp;
  lz2        : comp;
  prozent    : word;
  newstep    : word;
  xpos       : word;

begin
  newstep:= maxwert div pbaranzahl;
  if newstep= 0 then newstep:= 1;
  if (((value mod newstep)= 0) and (value> 0)) then
  begin
    write(chr(13));
    write(chr(27),'[',9,'C');
    r:= pbaranzahl;
    r:= (r / maxwert);
    zanz:= trunc(r * value);
    for b:= 0 to zanz do write(ch);

    xpos:= pbaranzahl + 1 + 9;
    write(chr(13));
    write(chr(27),'[',xpos,'C');

    prozent:= (value*100) div maxwert;
    ts:= DateTimeToTimeStamp(Now);
    lz2:= TimeStampToMSecs(ts);
    write (' ',prozent,'% ',((lz2 - startzeit) / 1000):3:2,'s  ');
  end;
end;

procedure txpbar100(startzeit : comp; pbaranzahl : byte);
var
  r               : real;
  b, b2, b3, zanz : byte;
  ts              : ttimestamp;
  lz2             : comp;
  prozent         : word;
  y				  : byte;
  newstep         : word;
  xpos            : word;
begin
  xpos:= pbaranzahl + 1 + 9;
  write(chr(13));
  write(chr(27),'[',xpos,'C');

  prozent:= 100;
  ts:= DateTimeToTimeStamp(Now);
  lz2:= TimeStampToMSecs(ts);
  write (' ',prozent,'% ',((lz2 - startzeit) / 1000):3:2,'s  ');
end;

procedure clr_inpuffer;
var
  ch     : char;
begin
  while (ser.waitingdataex> 0) do
  begin
    ch:= chr(ser.recvbyte(1));
    sleep(dtime_clear);
  end;
end;

procedure wait_inpuffer;
begin
  while (ser.waitingdataex= 0) do
  begin
  end;
end;

procedure sendadr16(val16 : word);
var
  w  : word;
  ch : char;
begin

  w:= val16;
  ub:= (w shr 12);
  ub:= ub and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  ser.sendbyte(ub);
  sleep(dtime_send);

  w:= val16;
  ub:= (w shr 8);
  ub:= ub and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  ser.sendbyte(ub);
  sleep(dtime_send);

  w:= val16;
  ub:= (w shr 4);
  ub:= ub and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  ser.sendbyte(ub);
  sleep(dtime_send);

  w:= val16;
  ub:= w and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  ser.sendbyte(ub);
  sleep(dtime_send);

  wait_inpuffer;

{*
    ch:= chr(ser.recvbyte(1));
    write(ch);
    ch:= chr(ser.recvbyte(1));
    write(ch);
    ch:= chr(ser.recvbyte(1));
    write(ch);
    ch:= chr(ser.recvbyte(1));
    write(ch);
*}

end;

function GetMcuId : byte;
var
  str2   : string[3];
  b      : byte;
  err    : integer;
begin
  ser.sendbyte(ord('8'));               // Read MCU-ID
  sleep(dtime_hi);
  repeat
    ch:= chr(ser.recvbyte(1));
  until (ch <> chr(0));

  str2:= ch;
  repeat
    ch:= chr(ser.recvbyte(1));
  until (ch <> chr(0));

  str2:= str2+ch;
  sleep(dtime_lo);
  val(str2,b,err);
  getmcuid:= b;
end;

function GetRS232Hex: string;
var
  str2   : string[3];
  b      : byte;
  err    : integer;

begin
  ch:= chr(ser.recvbyte(1));
  str2:= ch;
  ch:= chr(ser.recvbyte(1));
  str2:= str2+ch;
  sleep(dtime_lo);
  val(str2,b,err);
  getrs232hex:= str2;
end;

procedure FlashMCU(datnam : string);
var
  erranz  : word;
  banz    : word;
  wcx     : word;
  fms     : string;
  lz,lz2  : comp;
  ts,ts2  : ttimestamp;
  b1, b2  : byte;


begin
  highadress:= 0;
  assign(tdat,datnam);
  {$i-} reset(tdat); {$i+}
  if (ioresult <> 0) then
  begin
    writeln('Error: file ',datnam,' not found');
    halt;
  end;
  while(not(eof(tdat))) do
  begin
    readln(tdat,s);

    if (copy(s,1,1)= ':') then                      // Einleitung einer Zeile ":"
    begin
      if (copy(s,8,2)= '00') then                   // Position fuer "normale" Datenbytes
      begin
        hs:= '$'+copy(s,2,2);                       // Position fuer die Anzahl der Datenbytes
        val(hs,bytelen,err);
        dec(bytelen);
        hs:= '$'+copy(s,4,2);                       // Position Hi-Byte Speicheradresse
        val(hs,fadress,err);
        fadress:= fadress * 256;
        hs:= '$'+copy(s,6,2);
        val(hs,ub,err);
        fadress:= fadress+ub;

        for banz:= 0 to (( length(s)-11 ) div 2) - 1 do

        begin
          hs:= copy(s,10 +(banz * 2),1);
          hs2:= '$' + hs + copy(s,11 +(banz * 2),1);
          val(hs2,ub,err);
          binarray[fadress]:= ub;
          inc(fadress);
          if (fadress> highadress) then highadress:= fadress;

        end;

      end;
    end;
  end;
  close(tdat);
  dec(highadress);

  clr_inpuffer;

  ser.sendbyte(ord('1'));               // Erase Controller
  sleep(dtime_hi);
  sleep(dtime_hi);
  ch:= chr(ser.recvbyte(1));            // Programmer sendet ein 'e' zurueck

  ts:= DateTimeToTimeStamp(Now);
  lz:= TimeStampToMSecs(ts);

  str(highadress,fms);
  writeln('writing flash ('+fms+' bytes)');

  ser.sendbyte(ord('3'));
  sleep(dtime_hi);
  sendadr16(highadress);

  sleep(dtime_hi);

  ser.sendbyte(ord('6'));
  sleep(dtime_send);

  txpbarscala(50);
  write(chr(13));
  erranz:= 0;
  for wcx:= 0 to highadress do
  begin
    ub:= binarray[wcx];
    ub:= (ub shr 4);
    ub:= ub and $0f;
    if ub< 10 then ub:= ub+48 else ub:= ub+55;
    ser.sendbyte((ub));

    ub:= binarray[wcx];
    ub:= ub and $0f;
    if ub< 10 then ub:= ub+48 else ub:= ub+55;
    ser.sendbyte((ub));
    if ((mcuident> 50) or (mcuident< 70)) then (sleep(dtime_lo));
//    if (mcuident< 50) then (sleep(dtime_s2051));

    b1:= ser.recvbyte(1);
    b2:= ser.recvbyte(1);
    b1:= (b1 shl 4)+b2;
    if (b1 <> binarray[wcx]) then inc(erranz);

    if (mcuident> 70) then
      if ((wcx mod 64)= 0) then sleep(dtime_pagemode);

    if (mcuident< 50) then
      if ((wcx mod 32)= 0) then sleep(dtime_pagemode2);


    txpbar(lz,highadress, wcx, '#', 50);
//    write(chr(13));
//    ser.purge;
// if (ch<> 'O') then inc(erranz);
  end;
  txpbar100(lz, 50);

  str(erranz,fms);
  writeln(); writeln();
//  writeln('Communication errors: '+fms);
  writeln('flash51 done, thank you');

  ser.purge;

end;

procedure ResetMCU;
begin
  sleep(dtime_hi);
  ser.sendbyte(ord('4'));               // Reset Controller
  sleep(dtime_lo);
end;

function word2hex(val16 : word) : string;
var
  w  : word;
  ch : char;
  hs : string[6];
begin
  w:= val16;
  ub:= (w shr 12);
  ub:= ub and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  hs:= chr(ub);

  w:= val16;
  ub:= (w shr 8);
  ub:= ub and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  hs:= hs+chr(ub);

  w:= val16;
  ub:= (w shr 4);
  ub:= ub and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  hs:= hs+chr(ub);

  w:= val16;
  ub:= w and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  hs:= hs+chr(ub);

  word2hex:= hs;

end;

function byte2hex(val8 : word) : string;
var
  b  : word;
  hs : string[4];
begin

  b:= val8;
  ub:= (b shr 4);
  ub:= ub and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  hs:= chr(ub);

  b:= val8;
  ub:= b and $0f;
  if (ub< 10) then ub:= ub+ 48 else ub:= ub+55;                  // umwandeln nach Hex-Ziffer
  hs:= hs+chr(ub);

  byte2hex:= hs;

end;

procedure readcontroller(datnam : string);
var
  lz,lz2    : comp;
  ts,ts2    : ttimestamp;
  wcx,adrx  : word;
  hs        : string[4];
  err       : integer;
  b, pb	    : byte;

begin
  ser.sendbyte(ord('2'));               // Startadresse
  sleep(dtime_lo);
  sendadr16(0);
  sleep(dtime_med);
  ser.purge;

  ts:= DateTimeToTimeStamp(Now);
  lz:= TimeStampToMSecs(ts);

  ser.sendbyte(ord('3'));
  sleep(dtime_med);
  sendadr16(readlength);
  sleep(dtime_hi);
  ser.purge;

  ser.sendbyte(ord('7'));
  sleep(dtime_hi);
  while (ser.waitingdataex= 0) do
  begin
  end;
  txpbarscala2(50);
  write(chr(13));

  for wcx:= 0 to readlength do
  begin
    if ((wcx<> 0) and (wcx mod 16= 0)) then
    begin
//      writeln();
    end;
    repeat
      ch:= chr(ser.recvbyte(1));
    until ch<> chr(0);
//    write(ch);
    hs:= ch;
    repeat
      ch:= chr(ser.recvbyte(1));
    until ch<> chr(0);
    hs:= '$'+hs+ch;
    val(hs,b,err);
//    write(ch,' ',b,' ');
    binarray[wcx]:= b;
    txpbar(lz,readlength, wcx, '#', 50);
  end;
  txpbar100(lz, 50);
  writeln();

  assign(tdat,datnam);
  rewrite(tdat);

  for wcx:= 0 to readlength do
  begin
    if (wcx mod 16= 0) then
    begin
      write(tdat,':10',word2hex(wcx),'00');
      pb:= 0;
      for adrx:= 0 to 15 do
      begin
        b:= binarray[wcx+adrx];
        write(tdat,byte2hex(b));
        pb:= pb+b;
      end;
      pb:= pb+hi(wcx) + lo(wcx);
      pb:= not(pb);
      inc(pb);
      write(tdat,byte2hex(pb));
      writeln(tdat,'');
    end;
  end;
  writeln(tdat,':00000001FF');
  writeln(tdat,'');
  close(tdat);
end;

begin
  resmcu:= false;
  if (paramcount= 2) then
    if (paramstr(1) = 'res') then
      resmcu:= true;
  if ((paramcount< 3) and not(resmcu)) then
  begin
    writeln('Syntax:');
    writeln('flash51n action port filename [nowait]'); writeln();
    writeln('  action    : wr  = upload (write) file to mcu');
    writeln('              rd  = read (download) MCU to file');
    writeln('              res = reset microccontroller');
    writeln('  port      : port were the adapter is connected');
    writeln('  filename  : file to be uploaded');
    writeln('  nowait    : optional parameter: don'+chr(39)+'delay programstart');
    writeln('              You can use this option if you have');
    writeln('              a programmer WITHOUT a bootloader');
    writeln();
    writeln('  Example   : flash51n wr /dev/ttyUSB0 helloworld.ihx nowait');
    writeln();
    writeln();
    halt;
  end;

  portname:= paramstr(2);
  filename:= paramstr(3);
  readlength:= $1fff;
  if (paramcount= 4) then
    if (paramstr(4)= 'nowait') then
      nowait:= true
    else
      nowait:= false;


  sbaud:= 115200;
  sdbit:= 8;
  ssbit:= 1;
  sparity:= 'N';
  sport:= portname;

  ser:= tblockserial.create;
  ser.raiseExcept:= false;
  ser.linuxlock:= false;
  ser.connect(sport);
  ser.config(sbaud,sdbit,sparity,ssbit,false,false);

  writeln(^j^m'waiting for sync. adapter...');
  writeln();
  if (nowait= false) then sleep(1800);

  clr_inpuffer;
  mcuident:= getmcuid;
  sleep(dtime_clear);
  clr_inpuffer;
//  writeln('used Port: ',sport,chr(10));
//  writeln('mcu_id: ',mcuident);
  case mcuident of
    69: begin
          writeln('Device   : AT89S51 or AT89S52 with corrupted ID');
          writeln('pagemode : not used');
        end;
    52: begin
          writeln('Device   : AT89S52');
          writeln('pagemode : not used');

        end;
    51: begin
          writeln('Device   : AT89S51');
          writeln('pagemode : not used');
        end;
    23: begin
          writeln('Device   : AT89S2051');
          writeln('pagemode : 32 Byte');
        end;
    43: begin
          writeln('Device   : AT89S4051');
          writeln('pagemode : 32 Byte');
        end;
    73: begin
          writeln('Device   : AT89S8253');
          writeln('pagemode : 64 Byte');
        end;
  end;
  writeln();
  case paramstr(1) of
    'res' : begin
              writeln('Reset the mcu ... ');
              resetmcu;
              writeln('done, thank you');
              sleep(dtime_clear);
              clr_inpuffer;
            end;

    'wr'  : begin
              resetmcu;
              sleep(dtime_clear);
              clr_inpuffer;
              flashmcu(filename);

              resetmcu;
            end;

{*
    'rd'  : begin
              readcontroller(filename);
            end;
*}
  end;
  ser.free;
end.
